"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
* @category containers
* @component list-item
* @variations collab-ui-react
*/
var ListItemSection = function ListItemSection(props) {
  var children = props.children,
      className = props.className,
      position = props.position;
  return _react.default.createElement("div", {
    className: "cui-list-item__" + position + ("" + (className && " " + className || ''))
  }, children);
};

ListItemSection.propTypes = {
  /** @prop Children nodes to render inside ListItemSection | null */
  children: _propTypes.default.node,

  /** @prop Optional css class name | '' */
  className: _propTypes.default.string,

  /** @prop Determine the ListItemSection's position | 'center' */
  position: _propTypes.default.oneOf(['left', 'center', 'right', 'center-align'])
};
ListItemSection.defaultProps = {
  children: null,
  className: '',
  position: 'center'
};
ListItemSection.displayName = 'ListItemSection';
var _default = ListItemSection;
exports.default = _default;