"use strict";

exports.__esModule = true;
exports.default = void 0;

require("core-js/modules/es6.object.assign");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = require("lodash");

var _ = require("./..");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

/**
 * @category containers
 * @component select-option
 * @variations collab-ui-react
 */
var SelectOption =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(SelectOption, _React$Component);

  function SelectOption() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    _this.state = {
      id: _this.props.id || (0, _lodash.uniqueId)('cui-select-option-')
    };
    return _this;
  }

  var _proto = SelectOption.prototype;

  _proto.render = function render() {
    var _this$props = this.props,
        className = _this$props.className,
        isMulti = _this$props.isMulti,
        active = _this$props.active,
        children = _this$props.children,
        label = _this$props.label,
        title = _this$props.title,
        props = _objectWithoutPropertiesLoose(_this$props, ["className", "isMulti", "active", "children", "label", "title"]);

    var id = this.state.id;
    var separateChildren = isMulti ? _react.default.createElement(_.Checkbox, {
      htmlId: id + "__checkbox",
      label: label,
      checked: active,
      onChange: function onChange() {}
    }) : [_react.default.createElement(_.ListItemSection, {
      key: "child-0",
      position: "center"
    }, label || children), _react.default.createElement(_.ListItemSection, {
      key: "child-1",
      position: "right"
    }, active && _react.default.createElement(_.Icon, {
      color: "blue",
      name: "check_20"
    }))];
    return _react.default.createElement(_.ListItem, _extends({
      className: "" + (className && " " + className || ''),
      id: id,
      label: label,
      title: title || label
    }, props), separateChildren);
  };

  return SelectOption;
}(_react.default.Component);

SelectOption.propTypes = {
  /** @prop SelectOption Boolean that describes active state | false */
  active: _propTypes.default.bool,

  /** @prop Children nodes to render inside SelectOption | null */
  children: _propTypes.default.node,

  /** @prop Optional HTML Class Name for ListItem | '' */
  className: _propTypes.default.string,

  /** @prop SelectOption ID | '' */
  id: _propTypes.default.string,

  /** @prop Optional prop to know if multiple SelectOptions can be active | false */
  isMulti: _propTypes.default.bool,

  /** @prop SelectOption label text | '' */
  label: _propTypes.default.string,

  /** @prop ListItem Title | '' */
  title: _propTypes.default.string,

  /** @prop SelectOption value | '' */
  value: _propTypes.default.string
};
SelectOption.defaultProps = {
  active: false,
  children: null,
  className: '',
  id: '',
  isMulti: false,
  label: '',
  title: '',
  value: ''
};
SelectOption.displayName = 'SelectOption';
var _default = SelectOption;
exports.default = _default;